from urllib2 import urlopen

from libpaste import api

__all__ = ['PasteEntry', 'UnknownPastebin']

class PasteEntry(object):
    """
    Represents an entry on a pastebin somewhere.  Construct with a url, and
    if the pastebin is unsupported, UnknownPastebin will be raised.
    """
    def __init__(self, url):
        self.handler = None
        for conn in api.pastebins:
            if conn.can_handle(url):
                self.handler = conn(url)
                break
        if not self.handler:
            raise UnknownPastebin("No known pastebin handler for %r" % url)
        self.public_url = url
    #FIXME: property for raw_url that calls handler
    def raw_data(self):
        return self.handler.raw_data()

class UnknownPastebin(Exception): pass

class MissingPaste(Exception): pass

